# fichier d'exemple 'run' du projet

# project libs importations
import lib.ultra_mastermind_obj as libobj
import lib.ultra_mastermind_imp as libimp
import lib.ultra_mastermind_pp_imp as libppimp

# constants 
PM = ""
NG = 500
N  = 300
TS = 0.5
TM = 0.25
ALPHA = 0.5
FITNESS_METHOD = 3

# main function
def main() -> None:
    # Get phrase from user
    PM = input("Entrez une chaîne de caractères : ")
    while len(PM) < 4 and len(PM) > 30: PM = input("Entrez une chaîne de caractères : ")

    # object version
    # pop = libobj.Population(pm = PM, ng = NG, n = N, ts = TS, tm = TM, alpha = ALPHA, fm = FITNESS_METHOD)
    # pop.run()

    # imperative version
    # pop = libimp.new_population(PM, NG, N, TS, TM, ALPHA, FITNESS_METHOD)
    # libimp.run(pop)

    # imperative version ++
    pop = libppimp.new_population(PM, NG, N, TS, TM, ALPHA, FITNESS_METHOD)
    libppimp.run(pop)

if __name__ == "__main__":
	main()
